//
//  ViewController.swift
//  MacJsonToModelFile
//
//  Created by chenyehong on 2022/2/21.
//

import Cocoa

class ViewController: NSViewController {

    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    
    @IBOutlet weak var myScrollView: NSScrollView!
    let fileUtil = FileUtil.init()
    
    override var representedObject: Any? {
        didSet {
        // Update the view, if already loaded.
        }
    }

    @IBAction func clickStart(_ sender: Any) {
        let myTextView: NSTextView = myScrollView.documentView! as! NSTextView
        let myText:String = myTextView.string
        
        let data = myText.data(using: String.Encoding.utf8)
        if let dict = try? JSONSerialization.jsonObject(with: data!, options: JSONSerialization.ReadingOptions.mutableContainers) as? [String : Any] {
            
            print("转换成功")
            fileMap = [:]
            fileUtil.clearFile()
            handleDic("Result", dict as NSDictionary)
            
            for (key, value) in fileMap {
                fileUtil.createOcFile(value)
            }
//            return dict
        } else {
            print("请输入正确的json字符串")
        }
    }
    
    var prefix = "SLM"
    var fileMap : [String : FileModel] = [:]
    
    func handleDic(_ name : String, _ dic : NSDictionary) -> String {
        
        var fileName = "\(prefix)\(name.capitalized)"
        var count = 0
        while fileMap.contains(where: { (key: String, value: FileModel) in
            return key == fileName
        }) {
            count += 1
            fileName = "\(prefix)\(count)\(name.capitalized)"
        }
        let fileModel = FileModel.init()
        fileModel.fileName = fileName
        fileMap[fileModel.fileName!] = fileModel
        
        for (key, value) in dic {
            let pt = FileProperty.init()
            pt.propertyName = key as! String
            pt.propertyType = calPropertyType(pt.propertyName!, value)
            fileModel.propertys.append(pt)
        }
        
        return fileName
    }
    
    func calPropertyType(_ name : String, _ value : Any) -> PropertyType{
        if let value = value as? NSDictionary {
            let pName = handleDic(name, value)
            return PropertyType.model(pName)
        }
        if let array = value as? NSArray {
            if array.count > 0 {
                let obj = array[0]
                if let obj = obj as? NSDictionary {
                    let pName = handleDic(name, obj)
                    return PropertyType.list(ArrayItemType.model(pName))
                }
                if obj is String {
                    return PropertyType.list(.string)
                }
                if OcTool.isPureFloat(value) {
                    return PropertyType.list(.float)
                }
                if OcTool.isPureBool(value) {
                    return PropertyType.list(.bool)
                }
                if OcTool.isPureInt(value) {
                    return PropertyType.list(.int)
                }
            }
            return PropertyType.list(.id)
        }
        if value is String {
            return .string
        }
        if OcTool.isPureFloat(value) {
            return .float
        }
        if OcTool.isPureBool(value) {
            return .bool
        }
        if OcTool.isPureInt(value) {
            return .int
        }
        
        return .id
    }
}

